c     get a path corresponding to the passed
c                  index from an rdb table.
c
c     returns either a path or an empty string

      character*(*) function jmkpath( rdbfile, pathidx )

      character*256 rdbfile
      double precision pathidx

      external  lenact
      integer   lenact

      double precision idx
      integer i, line
      character*256 buf, filename
      character*512 xprtbuf
      character*1 tab
      data tab/'\t'/

      integer lun
      parameter ( lun = 98 )
      jmkpath = ' '

      call xwrite('jmkpath: scanning rdb file ' // rdbfile, 11)

c     open requested file
      open( unit=lun, file=rdbfile, status = 'old', err=900 )

c     read past any comments at beginning of file
      line = 1
 100  read( lun, '(a)', end=901 ) buf
      line = line + 1
      if ( buf(1:1) .eq. '#' ) goto 100

c     read second line in two line header. it isn't used, so ignore it
      read( lun, '(a)', end=901 ) buf
      line = line + 1

c     read in the table, stopping if the indices match.  In order to
c     keep this simple, only read the first two columns in the
c     table which must be 'index' and 'path', in that order

 200  read( lun, '(a)', end=903, err=902 ) buf
      line = line + 1

      i = index( buf, tab )
      if ( i .eq. 0 ) goto 902

      read( buf(1:i-1), *, err=902) idx
      if ( idx .ne. pathidx ) goto 200

      buf = buf(i+1:)
      i = index( buf, tab )
      if ( i .eq. 0 ) i = len(buf)
      read( buf(1:i-1),'(a)', err=902) filename

      close( lun )

      jmkpath = filename
      return

c     error opening file
 900  call xwrite( 'jmkpath: error opening ' // rdbfile, 1 )
      return

c     unexpected eof
 901  call xwrite( 'jmkpath: unexpected EOF on ' // rdbfile, 1 )
      close(lun)
      return

c     bad rdb row
 902  write( xprtbuf,
     $     '(''jmkpath: bad row in '',a,'' at line '',i)' )
     $     rdbfile(:lenact(rdbfile)), line
      call xwrite( xprtbuf, 1 )
      close(lun)
      return

c     didn't match index
 903  write( xprtbuf, 
     $     '(''jmkpath: couldn''''t find index'',f, '' in '',a)')
     $     pathidx, rdbfile(:lenact(rdbfile))
      call xwrite( xprtbuf, 1 )
      close(lun)
      return

      end
